+ UGen {
	freqClip { arg clipLo=3, clipHi=20000;
		^this.clip(clipLo, clipHi)
	}

	ffreqClean { arg clipLo=3, clipHi=20000, lagTime=0.005;
		^this.clip(clipLo, clipHi).lag(lagTime)
	}

	clean { arg dcCoef=0.995;
		^LeakDC.multiNew(this.rate, this.sanitize, dcCoef)
	}

	limit { arg releaseTime=0.5, holdTime=0.1;
		^SafetyLimiter.multiNew(this.rate, this, releaseTime, holdTime)
	}

	hp { arg freq=20;
		^HPF.multiNew(this.rate, this, freq)
	}

	lp { arg freq=18000;
		^LPF.multiNew(this.rate, this, freq)
	}
}

+ SimpleNumber {
	freqClip   { ^this }
	ffreqClean { ^this }
	clean      { ^this }
	limit      { ^this }
	hp         { ^this }
	lp         { ^this }
}

+ SequenceableCollection {
	freqClip { arg ... args;
		^this.multiChannelPerform('freqClip', *args)
	}

	ffreqClean { arg ... args;
		^this.multiChannelPerform('ffreqClean', *args)
	}

	clean { arg ... args;
		^this.multiChannelPerform('clean', *args)
	}

	limit { arg ... args;
		^this.multiChannelPerform('limit', *args)
	}

	hp { arg ... args;
		^this.multiChannelPerform('hp', *args)
	}

	lp { arg ... args;
		^this.multiChannelPerform('lp', *args)
	}
}
