// seg1

// reset proxy state
Require(z.ncUserDir ++ "liveset_pre/patches/lib/main");
Require(z.ncUserDir ++ "liveset_pre/patches/lib/lhpspace");
Ndef.clear;

// check proxy state
~lhpspace.activeProxies;
~lhpspace.existingProxies;
~lhpspace;

// change tempo on downbeat of first of every fourth bar
(
~lhpclock.play({
	~lhpclock.tempo = 160/60;
	~lhptempo = ~lhpclock.tempo;
	"tempo changed to: %\n".postf(~lhptempo * 60);
}, -4);
)

// run/pause clock poll task
z.clockPollTask.play(~lhpclock);
z.clockPollTask.pause;



// main proxies
(
Ndef(\fwdRevHat).clear.ar(2);
Ndef(\fwdRevHat).fadeTime = 0;
Ndef(\fwdRevHat).quant = -1;
Ndef(\fwdRevHat).addSpec(
	\atkScale, [0, 4],
	\relScale, [0, 2],
	\holdScale, [0, 2],
	\atkCurve, [-16, 16],
	\relCurve, [-16, 16],
	\brfFreq, [1e3, 15e3, \exp],
	\brfRq, [0.05, 2, \exp],
	\bpfFreq, [1e3, 16e3, \exp],
	\bpfRq, [0.05, 2, \exp],
	\holdAmp, \unipolar,
	\secondPeakAmp, \unipolar,
	\impPhase, \unipolar,
	\envDistPinch, [0.1, 4, \lin],
	\envDistVerbScale, \unipolar,
	\envDistVerbRoom, \unipolar,
	\envDistVerbDamp, \unipolar,
	\envDistRipCf, \unipolar,
	\envDistRipRes, \unipolar,
	\envDistRipDrive, [0.5, 3],
	\envDistScale, \unipolar
);
Ndef('fwdRevHat').set('relScale', 2.0, 'secondPeakScale', 0.29221474373988, 'relCurve', -3.978835978836, 'atkScale', 2.031746031746, 'brfFreq', 4767.3260238582, 'atkCurve', -9.3968253968254, 'bpfFreq', 7245.7893141113, 'impPhase', 0.4973544973545, 'holdAmp', 0.1957671957672, 'secondPeakAmp', 0.074074074074074, 'envDistPinch', 1.6269841269841, 'holdScale', 0.6031746031746, 'bpfRq', 1.3536295852792, 'brfRq', 0.16445117682133);


Ndef(\blurb).clear.ar(2);
Ndef(\blurb).fadeTime = 0;
Ndef(\blurb).quant = -1;

Ndef(\bVerb).clear.ar(2);
Ndef(\bVerb).fadeTime = 0;
Ndef(\bVerb).quant = -1;
Ndef(\bVerb).addSpec(
	\predelay, [0.0,0.1,\lin],
	\inDiffusion, [0.001,3,\exp],
	\tail, \unipolar,
	\feedback, \unipolar,
	\inputLPF, \unipolar,
	\inputHPF,\freq,
	\peakgain, [-6.0,6.0, \lin, 0.001,0],
	\rqscale, [0.5,2],
	\level_0, \bipolar,
	\level_1, \bipolar,
	\level_2, \bipolar,
	\level_3, \bipolar,
	\decay_sec, [0.0,5],
	\decay1_sec, [0.0,5],
	\damping, [0.0,1],
	\dispFreq, \freq,
	\dispRandRange, [1, 50, \lin, 0, 2],
	\dispAtkRandRange, [0.1, 40, \lin, 0, 7],
	\pitchShiftRatio, [0,4],
	\fwdRevHatLvl, [-100, 0],
	\blurbSendLvl, [-100, 0],
	\rewriteProcLvl, [-100, 0],
	\outGain, [-20, 30, \lin, 0, 0]

);

Ndef(\bufRewriteProcess).clear.ar(2);
Ndef(\bufRewriteProcess).fadeTime = 0;
Ndef(\bufRewriteProcess).quant = -1;
)


// precalculate graph functions
(
~fwdRevHatDef = {
	var sig, imp, env, envDistort;
	var atk, rel, hold, holdAmp, atkCurve, relCurve;
	var tempo;

	tempo = ~tempoproxy.kr;
	atk = 0.001;
	rel = tempo.reciprocal/4; // 16ths
	atk = atk * \atkScale.kr(1);
	rel = rel * \relScale.kr(1);
	hold = rel * 4 * \holdScale.kr(1);
	holdAmp = \holdAmp.kr(0);

	atkCurve = \atkCurve.kr(0);
	relCurve = \relCurve.kr(0);


	sig = WhiteNoise.ar;
	// sig = BRF.ar(sig, \brfFreq.kr(3000), \brfRq.kr(0.3));
	sig = BPF.ar(sig, \bpfFreq.kr(8000), \bpfRq.kr(1));
	imp = Impulse.ar(tempo/4,\impPhase.kr(0));
	env = Env([0,1,holdAmp, holdAmp,\secondPeakAmp.kr(0.3),0], [atk, rel, hold, rel, atk], [atkCurve, relCurve, 0, relCurve, atkCurve]).ar(gate: imp);
	envDistort = Phasor.ar(imp, Env([tempo*2, tempo*2, tempo/2], [atk+rel+hold, rel]).ar(gate: imp) * 2pi * SampleDur.ir, 0, 2pi).sin.abs.pow(\envDistPinch.kr(1)) * Delay1.ar(1-(LFSaw.ar(tempo/4, 1).range(1,-1) + LFSaw.ar(tempo/4, 1).range(0,1)).clip(0,1));
	env = env.blend(env * envDistort, \envDistScale.kr(0));
	env = env.blend(MiRipples.ar(FreeVerb.ar(env, 1, \envDistVerbRoom.kr(0.5), \envDistVerbDamp.kr(0.5)), \envDistRipCf.kr(0.3), \envDistRipRes.kr(0.2), \envDistRipDrive.kr(1)), \envDistVerbScale.kr(0));
	sig.dup * env * -10.dbamp
};

~blurbDef = {
	var sig;
	var trigger = Impulse.kr(~tempoproxy.kr/2 * 2.pow(LFDNoise0.kr(LFDNoise0.kr(3).range(0,4)).lincurve(-1,1,-3,5,14).round));
    var harmonics = SinOsc.kr(0.03, 0, 0.5, 0.5).range(0.0, 1.0);
    var timbre = LFTri.kr(0.07, 0, 0.5, 0.5).exprange(0.01, 0.8);
    var morph = LFTri.kr(0.11, 0, 0.5, 0.5).squared;
    var pitch = TIRand.kr(33, 34, trigger);
    var engine = 4;
	var sub = SinOsc.ar(pitch.midicps, 0, 0.1) * 0.5 * LFDNoise3.ar(144/60/8).range(-60,0).dbamp;

    var mi = MiPlaits.ar( pitch, engine, harmonics, timbre, morph,
        trigger: trigger, decay: 0.8, lpg_colour: 0.2, mul: 0.5);

    var trig = Dust.kr(1);
    var pit = Latch.kr(WhiteNoise.kr(), trig).range(30, 30).round;
	var struct = LFNoise2.kr(0.4).range(0,1).round(0.2).lag(0.02);

	sig = MiRings.ar(MiMu.ar(mi, 1), 0, pit, struct, 0.5, 0.9, 0.9, model: 2, poly: 4) * -15.dbamp + sub;
	NumChannels.ar(sig, 2)
};



~bVerbDef = {
	arg inAmp=0.8, scaleDelays=1, inDiffusion=0.05, feedback=0.5, decay_sec=0.5, decay1_sec=0.5, dispFreq=300,
	dispRandRange=2,dispAtkRandRange=7;

	var signal, tempo, tank, src, localin, times, dtimes, l, r;
	var sig0level, sig1level, sig2level, sig3level, sig4level;
	var earlyDiffDTimes, earlyDiffSize=4;
	var signalIn = [ Impulse.ar(178/60*0.25)* inAmp;  ] ++ DC.ar(0).dup(3);
	var sr = SampleRate.ir, sz = 4;

	tempo = ~tempoproxy.kr;

	sig0level = \fwdRevHatLvl.kr(-100, 0.1);
	sig1level = \blurbSendLvl.kr(-100, 0.1);
	sig2level = \rewriteProcLvl.kr(-100, 0.1);
	// sig3level = \blablaLvl.kr(-100, 0.1);
	// sig4level = \blablaLvl.kr(-100, 0.1);
	// sig5level = \blablaLvl.kr(-100, 0.1);

	signalIn = Silence.ar.dup;
	signalIn = Ndef(\blurb).ar * Select.kr(sig1level < (-90), [sig1level, -inf]).dbamp;
	signalIn = signalIn + (Ndef(\bufRewriteProcess).ar *  Select.kr(sig2level < (-90), [sig2level, -inf]).dbamp);
	signalIn = signalIn + (Ndef(\fwdRevHat) *  Select.kr(sig0level < (-90), [sig0level, -inf]).dbamp);


	signalIn = NumChannels.ar(signalIn, 4);

	src = HPF.ar(signalIn, \inputHPF.kr(150));
	src = OnePole.ar(src, \inputLPF.kr(0.5));

	src = DelayN.ar(src, 0.1, \predelay.kr(0.0));

	times = [ 1447, 727, 613, 673, 1439, 2083, 2011, 1511, 1493, 1277, 2437, 2383, 2341, 997, 1061, 2039, 1997, 1481, 1627, 1129, 743, 983, 1091, 907, 541, 2393, 1801, 2081, 1787, 1453, 977, 2311, 691, 479, 2377, 1693, 1013, 1931, 1049, 2243, 839, 739, 1747, 601, 1823, 1123, 2467, 1297, 1613, 1361, 2207, 593, 619, 1709, 449, 937 ];
	earlyDiffDTimes = { times.removeAt(times.minIndex) } ! ( earlyDiffSize * src.size );

	l = times.size.div(2).collect({|i| times[i*2]}) * scaleDelays;
	r = times.size.div(2).collect({|i| times[i*2 + 1]}) * scaleDelays;

	dtimes = Routine{(earlyDiffDTimes ++ l ++ r).do { |it|it.yield}};

	src.do { |it i|
		earlyDiffSize.do {
			var dt = dtimes.next / sr;
			src[i] = AllpassN.ar(src[i], dt, dt, inDiffusion);
		};

	};

	localin = LocalIn.ar(1);

	dispFreq = dispFreq + LFDNoise3.ar(Env.perc(0.1, 2, level:dispAtkRandRange).ar(gate:signalIn[0])).range(dispFreq/dispRandRange, dispFreq*dispRandRange);

	tank = sz.collect { |i|
		var dt0, dt1, dt2;

		localin = localin + src[i];

		dt0 = dtimes.next / sr;
		dt1 = dtimes.next / sr;
		dt2 = dtimes.next / sr;

		40.do {
			localin = Allpass1.ar(localin, dispFreq);
		};

		localin = AllpassC.ar(localin, dt0, dt0, decay_sec );
		localin = AllpassC.ar(localin, dt1, dt1, decay1_sec);

		localin = DelayC.ar(localin, dt2, dt2 - ( ControlDur.ir / sz )* LFNoise2.kr(0.3).range(0.9,1));

		localin = OnePole.ar(localin, \damping.kr(0.0) );

		// localin = localin * feedback;

	};

	tank = PitchShift.ar(tank, 0.2, \pitchShiftRatio.kr(1), 0.02, 0.03);

	LocalOut.ar( tank.last * feedback;);

	signal = 2.collect({|i|
		i = i*2;
		[
			tank[i] * ( "level_" ++ i ).asSymbol.kr(0),
			tank[i+1] * ( "level_" ++ ( i+1 ) ).asSymbol.kr(0)
		]
	}).sum;

	// signal = tank.sum;
	signal = LeakDC.ar(signal);

	signal * \tail.kr(1) * \outGain.kr(0).dbamp;
};


~bufRewriteProcessDef = {
	var sig, bufRd, bufPointer, localBuf, localBufSize = (60/160*8*44100);
	localBuf = LocalBuf(localBufSize, 2).clear;
	bufRd = BufRd.ar(2, localBuf, Phasor.ar(0,1,0,localBufSize), interpolation: 4) * 0.6;

	sig = Blip.ar([1,1.01],10)/5 + bufRd;
	// sig = Ndef(\fwdRevHat).ar + Ndef(\blurb).ar + bufRd;
	sig = GVerb.ar(sig, 6, 5, 0.7, drylevel: 0);
	sig = NumChannels.ar(sig,2) * -3.dbamp;
	sig = PitchShift.ar(sig, 0.2, 0.7, 0.00, 0);
	sig = sig.clean.limit;

	// bufPointer = LFNoise1.ar(0.3).range(0, BufFrames.kr(localBuf))/* + 1 * 5e4*/;
	bufPointer = LFDNoise3.ar(~tempoproxy.kr/4,1).range(BufFrames.kr(localBuf), 0);
	// bufPointer = LFNoise2.ar(1.3).range(BufFrames.kr(localBuf), 0);
	BufWr.ar(sig, localBuf, phase: bufPointer);

	NumChannels.ar(Compander.ar(GVerb.ar(bufRd, 20, 9, 0.9), Ndef(\bVerb).ar, 0.4, 0.7, 0.8) * -20.dbamp)
};


Ndef(\fwdRevHat, ~fwdRevHatDef);
Ndef(\blurb, ~blurbDef);
Ndef(\bVerb, ~bVerbDef);
Ndef(\bufRewriteProcess, ~bufRewriteProcessDef);
)




(
Ndef(\fwdRevHat, ~fwdRevHatDef).end;
Ndef(\blurb, ~blurbDef).end;
Ndef(\bVerb, ~bVerbDef).end;
Ndef(\bufRewriteProcess, ~bufRewriteProcessDef).end;
)

Ndef(\fwdRevHat).gui;
Ndef(\blurb).gui;
Ndef(\bVerb).gui;
Ndef(\bufRewriteProcess).gui;

Ndef(\trak1mixer).gui;




(
Ndef(\trak1mixer).clear;
Ndef(\trak1mixer).ar(2);
)
(
Ndef(\trak1mixer, {
	var local;
	var attack = \attack.kr(0.01);
	var release = \release.kr(0.1);
	var dry, drywet, in, t, o, r, c, e;
	var lookahead, lookdelay;
	var kneelag;
	var bias;
	var input, fwdRevHatIn, blurbIn, bVerbIn, bufRewriteProcIn;
	var fwdRevHatLvl, blurbLvl, bVerbLvl, bufRewriteProcLvl;


	fwdRevHatIn = Ndef(\fwdRevHat).ar;
	blurbIn = Ndef(\blurb).ar;
	bVerbIn = Ndef(\bVerb).ar;
	bufRewriteProcIn = Ndef(\bufRewriteProcess).ar;

	fwdRevHatLvl = \fwdRevHatLvl.kr(-100);
	blurbLvl = \blurbLvl.kr(-100);
	bVerbLvl = \bVerbLvl.kr(-100);
	bufRewriteProcLvl = \bufRewProcLvl.kr(-100);

	input = fwdRevHatIn * Select.kr(fwdRevHatLvl < (-90), [fwdRevHatLvl, -inf]).dbamp;
	input = input + (blurbIn * Select.kr(blurbLvl < (-90), [blurbLvl, -inf]).dbamp);
	input = input + (bVerbIn * Select.kr(bVerbLvl < (-90), [bVerbLvl, -inf]).dbamp);
	input = input + (bufRewriteProcIn * Select.kr(bufRewriteProcLvl < (-90), [bufRewriteProcLvl, -inf]).dbamp);

	dry = input;


	t = \threshold.kr(-6);

	in = dry * \trim.kr(0).dbamp;

	e = in.mean;

	e = HPF.ar(e, \hpf.kr(50));
	e = EnvDetect.ar(e, attack, release);

	o = e.ampdb.excess(t);

	r = \ratio.kr(4);
	c = max(o, 0.0) * (r.reciprocal - 1);
	kneelag = attack * \knee.kr(0.0);
	c = c.lag(kneelag);
	c = c.dbamp;

	lookahead = \lookahead.kr(0);
	lookdelay = (attack + release + kneelag * lookahead).lag(0.4);
	in = DelayC.ar(in, 0.5, lookdelay);
	in = in * c;
	in = in * \gain.kr(0).dbamp;
	in = Select.ar(\saturate.kr(1), [in, in.softclip]);
	in = LeakDC.ar(in);

	drywet = \dry_wet.kr(1);
	Mix([
		in * drywet,
		DelayC.ar(dry * (1 - drywet), 0.5, lookdelay)
	])

});
)
(
Ndef(\trak1mixer).addSpec(
	\fwdRevHatLvl, [-100, 0, \lin, 0, -100],
	\blurbLvl, [-100, 0, \lin, 0, -100],
	\bVerbLvl, [-100, 0, \lin, 0, -100],
	\bufRewProcLvl, [-100, 0, \lin, 0, -100],
	\attack, [0.0000001,0.1, \exp],
	\release, [0.0000001,0.4, \exp],
	\threshold, [0,-120],
	\trim, [0,60],
	\gain, [0,60],
	\ratio, [1,20, \exp],
	\lookahead, [0.0,1],
	\saturate, \switch,
	\dry_wet, [0,1],
	\hpf, [10, 1000] ,
	\knee, [0.0, 10] ,
	\bias, [0.0, 0.5] ,
);
)
Ndef(\trak1mixer).gui




Ndef(\fwdRevHat).clear.ar(2);
Ndef(\fwdRevHat).fadeTime = 0;
Ndef(\fwdRevHat).quant = -1;

(
Ndef(\fwdRevHat, {
	var sig, imp, env, envDistort;
	var atk, rel, hold, holdAmp, atkCurve, relCurve;
	var tempo;

	tempo = ~tempoproxy.kr;
	atk = 0.001;
	rel = tempo.reciprocal/4; // 16ths
	atk = atk * \atkScale.kr(1);
	rel = rel * \relScale.kr(1);
	hold = rel * 4 * \holdScale.kr(1);
	holdAmp = \holdAmp.kr(0);

	atkCurve = \atkCurve.kr(0);
	relCurve = \relCurve.kr(0);


	sig = WhiteNoise.ar;
	// sig = BRF.ar(sig, \brfFreq.kr(3000), \brfRq.kr(0.3));
	sig = BPF.ar(sig, \bpfFreq.kr(8000), \bpfRq.kr(1));
	imp = Impulse.ar(tempo/4,\impPhase.kr(0));
	env = Env([0,1,holdAmp, holdAmp,\secondPeakAmp.kr(0.3),0], [atk, rel, hold, rel, atk], [atkCurve, relCurve, 0, relCurve, atkCurve]).ar(gate: imp);
	envDistort = Phasor.ar(imp, Env([tempo*2, tempo*2, tempo/2], [atk+rel+hold, rel]).ar(gate: imp) * 2pi * SampleDur.ir, 0, 2pi).sin.abs.pow(\envDistPinch.kr(1)) * Delay1.ar(1-(LFSaw.ar(tempo/4, 1).range(1,-1) + LFSaw.ar(tempo/4, 1).range(0,1)).clip(0,1));
	env = env.blend(env * envDistort, \envDistScale.kr(0));
	env = env.blend(MiRipples.ar(FreeVerb.ar(env, 1, \envDistVerbRoom.kr(0.5), \envDistVerbDamp.kr(0.5)), \envDistRipCf.kr(0.3), \envDistRipRes.kr(0.2), \envDistRipDrive.kr(1)), \envDistVerbScale.kr(0));
	sig.dup * env * -10.dbamp
});
Ndef(\fwdRevHat).addSpec(
	\atkScale, [0, 4],
	\relScale, [0, 2],
	\holdScale, [0, 2],
	\atkCurve, [-16, 16],
	\relCurve, [-16, 16],
	\brfFreq, [1e3, 15e3, \exp],
	\brfRq, [0.05, 2, \exp],
	\bpfFreq, [1e3, 16e3, \exp],
	\bpfRq, [0.05, 2, \exp],
	\holdAmp, \unipolar,
	\secondPeakAmp, \unipolar,
	\impPhase, \unipolar,
	\envDistPinch, [0.1, 4, \lin],
	\envDistVerbScale, \unipolar,
	\envDistVerbRoom, \unipolar,
	\envDistVerbDamp, \unipolar,
	\envDistRipCf, \unipolar,
	\envDistRipRes, \unipolar,
	\envDistRipDrive, [0.5, 3],
	\envDistScale, \unipolar
);
Ndef('fwdRevHat').set('relScale', 2.0, 'secondPeakScale', 0.29221474373988, 'relCurve', -3.978835978836, 'atkScale', 2.031746031746, 'brfFreq', 4767.3260238582, 'atkCurve', -9.3968253968254, 'bpfFreq', 7245.7893141113, 'impPhase', 0.4973544973545, 'holdAmp', 0.1957671957672, 'secondPeakAmp', 0.074074074074074, 'envDistPinch', 1.6269841269841, 'holdScale', 0.6031746031746, 'bpfRq', 1.3536295852792, 'brfRq', 0.16445117682133);

)

Ndef(\fwdRevHat).play
Ndef(\fwdRevHat).stop(10)
Ndef(\fwdRevHat).end
Ndef(\fwdRevHat).gui




Ndef(\blurb).clear.ar(2);
Ndef(\blurb).fadeTime = 0;
Ndef(\blurb).quant = -1;
(
Ndef(\blurb, {
	var sig;
	var trigger = Impulse.kr(~tempoproxy.kr/2 * 2.pow(LFDNoise0.kr(LFDNoise0.kr(3).range(0,4)).lincurve(-1,1,-3,5,14).round));
    var harmonics = SinOsc.kr(0.03, 0, 0.5, 0.5).range(0.0, 1.0);
    var timbre = LFTri.kr(0.07, 0, 0.5, 0.5).exprange(0.01, 0.8);
    var morph = LFTri.kr(0.11, 0, 0.5, 0.5).squared;
    var pitch = TIRand.kr(33, 34, trigger);
    var engine = 4;
	var sub = SinOsc.ar(pitch.midicps, 0, 0.1) * 0.5 * LFDNoise3.ar(144/60/8).range(-60,0).dbamp;

    var mi = MiPlaits.ar( pitch, engine, harmonics, timbre, morph,
        trigger: trigger, decay: 0.8, lpg_colour: 0.2, mul: 0.5);

    var trig = Dust.kr(1);
    var pit = Latch.kr(WhiteNoise.kr(), trig).range(30, 30).round;
	var struct = LFNoise2.kr(0.4).range(0,1).round(0.2).lag(0.02);

	sig = MiRings.ar(MiMu.ar(mi, 1), 0, pit, struct, 0.5, 0.9, 0.9, model: 2, poly: 4) * -15.dbamp + sub;
	NumChannels.ar(sig, 2)
});
)

Ndef(\blurb).play
Ndef(\blurb).stop
Ndef(\blurb).end
Ndef(\blurb).gui




Ndef(\bVerb).clear.ar(2);
Ndef(\bVerb).fadeTime = 0;
Ndef(\bVerb).quant = -1;

(
Ndef(\bVerb, {
	arg inAmp=0.8, scaleDelays=1, inDiffusion=0.05, feedback=0.5, decay_sec=0.5, decay1_sec=0.5, dispFreq=300,
	dispRandRange=2,dispAtkRandRange=7;

	var signal, tempo, tank, src, localin, times, dtimes, l, r;
	var sig0level, sig1level, sig2level, sig3level, sig4level;
	var earlyDiffDTimes, earlyDiffSize=4;
	var signalIn = [ Impulse.ar(178/60*0.25)* inAmp;  ] ++ DC.ar(0).dup(3);
	var sr = SampleRate.ir, sz = 4;

	tempo = ~tempoproxy.kr;

	sig0level = \fwdRevHatLvl.kr(-100, 0.1);
	sig1level = \blurbSendLvl.kr(-100, 0.1);
	sig2level = \rewriteProcLvl.kr(-100, 0.1);
	// sig3level = \blablaLvl.kr(-100, 0.1);
	// sig4level = \blablaLvl.kr(-100, 0.1);
	// sig5level = \blablaLvl.kr(-100, 0.1);

	signalIn = Silence.ar.dup;
	signalIn = Ndef(\blurb).ar * Select.kr(sig1level < (-90), [sig1level, -inf]).dbamp;
	signalIn = signalIn + (Ndef(\bufRewriteProcess).ar *  Select.kr(sig2level < (-90), [sig2level, -inf]).dbamp);
	signalIn = signalIn + (Ndef(\fwdRevHat) *  Select.kr(sig0level < (-90), [sig0level, -inf]).dbamp);


	signalIn = NumChannels.ar(signalIn, 4);

	src = HPF.ar(signalIn, \inputHPF.kr(150));
	src = OnePole.ar(src, \inputLPF.kr(0.5));

	src = DelayN.ar(src, 0.1, \predelay.kr(0.0));

	times = [ 1447, 727, 613, 673, 1439, 2083, 2011, 1511, 1493, 1277, 2437, 2383, 2341, 997, 1061, 2039, 1997, 1481, 1627, 1129, 743, 983, 1091, 907, 541, 2393, 1801, 2081, 1787, 1453, 977, 2311, 691, 479, 2377, 1693, 1013, 1931, 1049, 2243, 839, 739, 1747, 601, 1823, 1123, 2467, 1297, 1613, 1361, 2207, 593, 619, 1709, 449, 937 ];
	earlyDiffDTimes = { times.removeAt(times.minIndex) } ! ( earlyDiffSize * src.size );

	l = times.size.div(2).collect({|i| times[i*2]}) * scaleDelays;
	r = times.size.div(2).collect({|i| times[i*2 + 1]}) * scaleDelays;

	dtimes = Routine{(earlyDiffDTimes ++ l ++ r).do { |it|it.yield}};

	src.do { |it i|
		earlyDiffSize.do {
			var dt = dtimes.next / sr;
			src[i] = AllpassN.ar(src[i], dt, dt, inDiffusion);
		};

	};

	localin = LocalIn.ar(1);

	dispFreq = dispFreq + LFDNoise3.ar(Env.perc(0.1, 2, level:dispAtkRandRange).ar(gate:signalIn[0])).range(dispFreq/dispRandRange, dispFreq*dispRandRange);

	tank = sz.collect { |i|
		var dt0, dt1, dt2;

		localin = localin + src[i];

		dt0 = dtimes.next / sr;
		dt1 = dtimes.next / sr;
		dt2 = dtimes.next / sr;

		40.do {
			localin = Allpass1.ar(localin, dispFreq);
		};

		localin = AllpassC.ar(localin, dt0, dt0, decay_sec );
		localin = AllpassC.ar(localin, dt1, dt1, decay1_sec);

		localin = DelayC.ar(localin, dt2, dt2 - ( ControlDur.ir / sz )* LFNoise2.kr(0.3).range(0.9,1));

		localin = OnePole.ar(localin, \damping.kr(0.0) );

		// localin = localin * feedback;

	};

	tank = PitchShift.ar(tank, 0.2, \pitchShiftRatio.kr(1), 0.02, 0.03);

	LocalOut.ar( tank.last * feedback;);

	signal = 2.collect({|i|
		i = i*2;
		[
			tank[i] * ( "level_" ++ i ).asSymbol.kr(0),
			tank[i+1] * ( "level_" ++ ( i+1 ) ).asSymbol.kr(0)
		]
	}).sum;

	// signal = tank.sum;
	signal = LeakDC.ar(signal);

	signal * \tail.kr(1) * \outGain.kr(0).dbamp;
});
Ndef(\bVerb).addSpec(
	\predelay, [0.0,0.1,\lin],
	\inDiffusion, [0.001,3,\exp],
	\tail, \unipolar,
	\feedback, \unipolar,
	\inputLPF, \unipolar,
	\inputHPF,\freq,
	\peakgain, [-6.0,6.0, \lin, 0.001,0],
	\rqscale, [0.5,2],
	\level_0, \bipolar,
	\level_1, \bipolar,
	\level_2, \bipolar,
	\level_3, \bipolar,
	\decay_sec, [0.0,5],
	\decay1_sec, [0.0,5],
	\damping, [0.0,1],
	\dispFreq, \freq,
	\dispRandRange, [1, 50, \lin, 0, 2],
	\dispAtkRandRange, [0.1, 40, \lin, 0, 7],
	\pitchShiftRatio, [0,4],
	\fwdRevHatLvl, [-100, 0],
	\blurbSendLvl, [-100, 0],
	\rewriteProcLvl, [-100, 0],
	\outGain, [-20, 30, \lin, 0, 0]
);
)

Ndef(\bVerb).play
Ndef(\bVerb).stop
Ndef(\bVerb).end
Ndef(\bVerb).gui




(
Ndef(\tickTester).clear.ar(2);
Ndef(\tickTester, { Pan2.ar(Decay2.ar(~tick.ar, 0.005, 0.4) * PinkNoise.ar(-15.dbamp), 0) });
Ndef(\tickTester).play;
)

Ndef(\tickTester).end.clear;




Ndef(\bufRewriteProcess).clear.ar(2);
Ndef(\bufRewriteProcess).fadeTime = 0;
Ndef(\bufRewriteProcess).quant = -1;
(
Ndef(\bufRewriteProcess, {
	var sig, bufRd, bufPointer, localBuf, localBufSize = (60/160*8*44100);
	localBuf = LocalBuf(localBufSize, 2).clear;
	bufRd = BufRd.ar(2, localBuf, Phasor.ar(0,1,0,localBufSize), interpolation: 4) * 0.6;

	sig = Blip.ar([1,1.01],10)/5 + bufRd;
	// sig = Ndef(\fwdRevHat).ar + Ndef(\blurb).ar + bufRd;
	sig = GVerb.ar(sig, 6, 5, 0.7, drylevel: 0);
	sig = NumChannels.ar(sig,2) * -3.dbamp;
	sig = PitchShift.ar(sig, 0.2, 0.7, 0.00, 0);
	sig = sig.clean.limit;

	// bufPointer = LFNoise1.ar(0.3).range(0, BufFrames.kr(localBuf))/* + 1 * 5e4*/;
	bufPointer = LFDNoise3.ar(~tempoproxy.kr/4,1).range(BufFrames.kr(localBuf), 0);
	// bufPointer = LFNoise2.ar(1.3).range(BufFrames.kr(localBuf), 0);
	BufWr.ar(sig, localBuf, phase: bufPointer);

	NumChannels.ar(Compander.ar(GVerb.ar(bufRd, 20, 9, 0.9), Ndef(\bVerb).ar, 0.4, 0.7, 0.8) * -20.dbamp)
});
)
Ndef(\bufRewriteProcess).play
Ndef(\bufRewriteProcess).stop
Ndef(\bufRewriteProcess).end
Ndef(\bufRewriteProcess).gui
