// seg2

/*
from server reboot on:


1. eval first block (START PROXIES, SET GENERAL SETTINGS, SET CONTROLS TO INIT PRESET, ADD SPECS)
2. eval second block (DEFINE GRAPH FUNCTIONS)
3. eval trak2mixer graph funcion def
4. open trak2mixer gui
5. open del4 gui


6. decent levels: kik 0db, zap -5db, sub 0db, del -9.5db
*/

// start proxies, set general settings, set controls to init preset, add specs
// att: clears all ndefs
(
Ndef(\zap).clear.ar(2);
Ndef(\zap).fadeTime = 0;
Ndef(\zap).quant = -4;
Ndef('zap').set('zapEnvCur', -8.7301587301587, 'zapPitchEnvLo', 140.13241651547, 'zapEnvTime', 0.17946024402973, 'zapPitchEnvHi', 10066.828617371);
Ndef(\zap).addSpec(
	\zapEnvTime, [0.001, 1, \exp],
	\zapEnvCur, [-20, 10, \lin, 0, 0],
	\zapPitchEnvHi, [300, 12000, \exp],
	\zapPitchEnvLo, [10, 6000, \exp],
);

Ndef(\kik).clear.ar(2);
Ndef(\kik).fadeTime = 0;
Ndef(\kik).quant = -4;
Ndef(\kik).addSpec(
	\fundamental, [20, 300, \exp, 0, 52],
	\pitchLo, [0.1, 2, \lin, 0, 0.8],
	\pitchDur, [0, 1.3, \lin, 0, 0.14],
	\pitchCurve, [-10, 10, \lin, 0, 0],
	\decay, [0, 1.3, \lin, 0, 0.2]
);
Ndef('kik').set('decay', 0.075661375661376, 'pitchLo', 0.91428571428571, 'pitchCurve', -7.5661375661376, 'fundamental', 40.midicps, 'pitchDur', 0.048148148148148);




Ndef(\sub).clear.ar(2);
Ndef(\sub).fadeTime = 0;
Ndef(\sub).quant = -4;
Ndef(\sub).addSpec(
	\fundamental, [20, 300, \exp, 0, 49],
	\pitchLo, [0.1, 2, \lin, 0, 0.8],
	\pitchDur, [0, 1.3, \lin, 0, 0.14],
	\pitchCurve, [-10, 10, \lin, 0, 0],
	\decay, [0, 1.3, \lin, 0, 0.2]
);




Ndef(\del4).clear.ar(2);
Ndef(\del4).fadeTime = 0.07;
Ndef(\del4).quant = -4;
Ndef(\del4).addSpec(
	\phasorfreq, [0, 10],
	\phasoramp, [0, 400],
	\constdelay, [0, 300],
	\apfreq, \freq,
	\fbbase, [1, 200, \exp, 0, 4],
	\fbgain, [0.4,1.5, \lin, 0, 1.1],
	\kikLvl, [-100, 0, \lin, 0, -100],
	\zapLvl, [-100, 0, \lin, 0, -100],
	\subLvl, [-100, 0, \lin, 0, -100],
	\compSendKik, [-100, 20, \lin, 0, -100],
	\compSendZap, [-100, 20, \lin, 0, -100],
	\compSendSub, [-100, 20, \lin, 0, -100],
	\compAtk, [0.0001, 0.1, \exp, 0, 0.001],
	\compRel, [0.01, 0.3, \exp, 0, 0.03],
	\compThresh, [-90, 0, \lin, 0, -5, 0],
	\compRatio, [1, 40, \lin, 0, 4],
	\verbBlendAmt, \unipolar,
	\outputGain, [-40, 40, \lin, 0, 0],
	\damping, \unipolar,
	\subBassGainRed, [-30, 5, \lin, 0, -15],
);
)




// change tempo on downbeat of first of every fourth bar
(
~lhpclock.play({
	~lhpclock.tempo = 194/60;
	~lhptempo = ~lhpclock.tempo;
	"tempo changed to: %\n".postf(~lhptempo * 60);
}, -4);
)
~lhpclock.sync(192/60, 20, 0.05);




// precalculate graph functions
(
~zapDef = {
	var imp, tempo, seq, hit;
	var zap, zapPitchEnv, zapAmpEnv, zapEnvTime, zapEnvCur, zapPitchEnvHi;

	tempo = ~tempoproxy.kr;
	imp = Impulse.ar(tempo*4);

	seq = [
		[ 1, 0, 0, 1,  1, 0, 1, 1,  0, 1, 0, 0,  1, 0, 0, 1 ],
		[ 1, 0, 1, 0,  0, 0, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 ],
		[ 1, 0, 0, 1,  0, 0, 1, 0,  1, 0, 0, 0,  0, 1, 0, 1 ],
		[ 0, 0, 1, 1,  0, 0, 0, 0,  1, 0, 0, 0,  1, 0, 0, 0 ],

		[ 1, 0, 1, 0,  0, 0, 0, 1,  0, 0, 1, 1,  1, 0, 0, 1 ],
		[ 0, 1, 0, 0,  0, 0, 1, 0,  0, 1, 0, 1,  0, 0, 0, 0 ],
		[ 1, 0, 0, 1,  0, 0, 1, 0,  1, 0, 0, 0,  0, 1, 1, 1 ],
		[ 0, 0, 1, 1,  0, 0, 0, 0,  1, 0, 0, 0,  1, 0, 0, 0 ]
	].flat;

	seq = [
		[ 0, 0, 0, 0,  1, 0, 0, 0,  0, 0, 0, 0,  1, 0, 0, 0 ],
		[ 0, 0, 0, 0,  0, 0, 1, 0,  0, 0, 0, 0,  0, 1, 0, 0 ],
		[ 0, 0, 0, 0,  1, 0, 0, 0,  0, 0, 0, 0,  1, 0, 0, 0 ],
		[ 0, 0, 0, 0,  1, 0, 1, 0,  0, 1, 0, 0,  1, 0, 0, 0 ],

		[ 0, 0, 0, 0,  1, 0, 0, 0,  0, 0, 0, 0,  1, 0, 0, 0 ],
		[ 0, 0, 0, 0,  0, 0, 1, 0,  0, 0, 0, 0,  0, 1, 0, 0 ],
		[ 0, 0, 0, 0,  1, 0, 0, 0,  0, 0, 0, 0,  1, 0, 0, 0 ],
		[ 0, 0, 0, 0,  1, 0, 1, 0,  0, 1, 0, 0,  1, 0, 0, 0 ],

		[ 0, 0, 0, 0,  1, 0, 0, 0,  0, 0, 0, 0,  1, 0, 0, 0 ],
		[ 0, 0, 0, 0,  0, 0, 1, 0,  0, 0, 0, 0,  0, 1, 0, 0 ],
		[ 0, 0, 0, 0,  1, 0, 0, 0,  0, 0, 0, 0,  1, 0, 0, 0 ],
		[ 0, 0, 0, 0,  1, 0, 1, 0,  0, 1, 0, 0,  1, 0, 0, 0 ],

		[ 0, 0, 0, 0,  1, 0, 0, 0,  0, 0, 0, 0,  1, 0, 0, 0 ],
		[ 0, 0, 0, 0,  0, 0, 1, 0,  0, 0, 0, 0,  0, 1, 0, 0 ],
		[ 0, 0, 0, 0,  1, 0, 0, 0,  0, 0, 0, 0,  1, 0, 0, 0 ],
		[ 0, 0, 0, 1,  1, 0, 0, 0,  0, 0, 0, 1,  1, 0, 0, 0 ],

	].flat;


	hit = Demand.ar(imp, Impulse.ar(0), Dseq(seq,inf)) * imp;

	zapEnvTime = \zapEnvTime.kr(0.1);
	zapEnvCur = \zapEnvCur.kr(0);

	zapPitchEnvHi = \zapPitchEnvHi.kr(9e3);
	zapPitchEnv = Env.perc(0, zapEnvTime, 1, zapEnvCur).ar(gate: hit).linexp(0, 1, \zapPitchEnvLo.kr(100), zapPitchEnvHi);
	zapAmpEnv = Env.perc(0, zapEnvTime, 1, zapEnvCur).ar(gate: hit);
	zap = SinOsc.ar(zapPitchEnv) * zapAmpEnv;
	// zap = PulseDPW.ar(\f1.asNote.midicps, 0.4, 0.4) * zapAmpEnv;
	zap = SVF.ar(zap, zapPitchEnv.lag(0.1), 0.8, 1);
	// zap = zap + MiPlaits.ar(zapPitchEnv, 8, 0.05, 0.1, 0.5, zap.dup, decay: 0.9, lpg_colour: 0.1);
	// zap = AnalogFoldOsc

	Pan2.ar(zap) * -30.dbamp
};

~kikDef = {
	var imp, tempo, seq, hit;
	var kik, kikPitchEnv;

	tempo = ~tempoproxy.kr;
	// (tempo * 60).poll;
	imp = Impulse.ar(tempo*2);

	seq = [
		[ 1, 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0 ],
		[ 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0 ],
		[ 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 1 ],
		[ 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0 ],

		[ 1, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0 ],
		[ 0, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0 ],
		[ 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1 ],
		[ 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0 ],

		[ 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 0, 1, 0 ],
		[ 0, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0 ],
		[ 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1 ],
		[ 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0 ],

		[ 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0 ],
		[ 0, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0 ],
		[ 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1 ],
		[ 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0 ]
	].flat;

	hit = Demand.ar(imp, Impulse.ar(0), Dseq(seq,inf)) * imp;
	kikPitchEnv = Env([1,1,\pitchLo.kr(0.8)], [0.01, \pitchDur.kr(0.14)], \pitchCurve.kr(0)).ar(gate: hit);
	// kik = Ringz.ar(hit.lp(700), \fundamental.kr(52) * XLine.ar(1, \pitchLo.kr(0.8), \pitchDur.kr(0.14)), \decay.kr(0.2)) * -5.dbamp;
	kik = Ringz.ar(hit.lp(700), \fundamental.kr(52) * kikPitchEnv, \decay.kr(0.2)) * \outGain.kr(5).dbamp;

	Pan2.ar(kik) * -10.dbamp
};


~subDef = {
	var sig, imp, tempo, seq, hit;
	var kik, kikPitchEnv;
	var env, formantEnv, verb, verbLp, verbHp, verbFilterEnv;
	var mod = SinOsc.kr(0.1);


	tempo = ~tempoproxy.kr;
	// (tempo * 60).poll;
	imp = Impulse.ar(tempo*2);

	seq = [
		[ 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0 ],
		[ 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0 ]
	].flat;

	seq = [
		[ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0 ],
		[ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
	].flat;

	hit = Demand.ar(imp, Impulse.ar(0), Dseq(seq,inf)) * imp;

	env = Env.perc(tempo.reciprocal / 16, 0.5, 1, \welch).ar(gate: hit);
	formantEnv = Env([0,2pi,0], [tempo/8, tempo/4]).ar(gate: hit).sin.pow(tempo).exprange(1, 60);
	formantEnv = SinOsc.kr(tempo/2).pow(tempo * 1).exprange(1,LFDNoise3.kr(0.6).range(70, 70));

	sig = ZOsc.ar(
		freq: (40-9).midicps * LFNoise2.kr(0.5).exprange(0.995,1.005),
		formantfreq: formantEnv,
		shape: 0.99,
		mode: -0.99
	);
	sig = sig.hp(100) * env;
	sig = sig.blend(BPeakEQ.ar(sig, 120, 1.6, -10), 0.5);
	verb = DWGReverbC1C3.ar(sig.hp(100), 2000, 1.8, 100, 1);

	verbFilterEnv = Env([40, 8000, 40], [0.03, tempo.reciprocal/8], -3).ar(gate: hit).lag(0.1);
	// verbHp = SVF.ar(verb, LFSaw.ar(tempo*2, 1.2).exprange(8000, 10).lag(0.3), 0.8, 0, 0, 1); // adjust second arg of lfsaw
	verbHp = SVF.ar(verb, verbFilterEnv, 0.7, 0, 0, 0.8);
	verbHp = verbHp * Env([0,0,1], [0.4, tempo.reciprocal/4], -5).ar(gate: hit);
	// verbHp = verbHp * Env.asr(0.03, 1, tempo.reciprocal/8*0.1, 3).ar(gate: Trig1.kr(hit, tempo.reciprocal/16)).poll;
	verbHp = verbHp.blend(BPeakEQ.ar(verbHp, 360, 1.2, 20), 0.3);
	// verbHp = verbHp + CombC.ar(verbHp * -9.dbamp, 0.55, 0.55, tempo.reciprocal * 0.8);
	verb = verbHp.hp(340);
	verb = NumChannels.ar(verb);
	sig = sig.blend(verb, 0.3);
	Pan2.ar((sig * 1.3).tanh * -19.dbamp, 0);
};

~delDef = {
	|phasorfreq=(2.3), phasoramp=120, constdelay=73, apfreq=1000, rmswindow=512, fbbase=120, fbgain=1.1|
	var input, inputenv, fb, output;
	var kikIn, zapIn, subIn;
	var compSendSig, compSendKikLvl, compSendZapLvl, compSendSubLvl;
	var signalIn, sig0level, sig1level, sig2level, sig3level, sig4level, sig5level;
	var phasor, dellinetime, dellineenv, delline;
	var delays, rms;
	var ph, dt, de, del;
	var amplitudeDb, gainDb;
	var attack = 0.001, release = 0.03;
	var threshold = (-10), ratio=4;

	sig0level = \kikLvl.kr(-100, 0.1);
	sig1level = \zapLvl.kr(-100, 0.1);
	sig2level = \subLvl.kr(-100, 0.1);
	// sig3level = \blablaLvl.kr(-100, 0.1);
	// sig4level = \blablaLvl.kr(-100, 0.1);
	// sig5level = \blablaLvl.kr(-100, 0.1);

	kikIn = Ndef(\kik).ar;
	zapIn = Ndef(\zap).ar;
	subIn = Ndef(\sub).ar;

	signalIn = Silence.ar.dup;
	signalIn = kikIn * Select.kr(sig0level < (-90), [sig0level, -inf]).dbamp;
	signalIn = signalIn + (zapIn * Select.kr(sig1level < (-90), [sig1level, -inf]).dbamp);
	signalIn = signalIn + (subIn * Select.kr(sig2level < (-90), [sig2level, -inf]).dbamp);

	// input = Impulse.ar(144/60/4);
	input = signalIn;



	// input = LPF.ar( Ringz.ar(input, 51 * XLine.ar(1, 0.8, 0.14), 0.8 ), 700 ) * -5.dbamp;
	// input = Blip.ar(60.midicps, mul: 0.1);
	inputenv = Env([-120.dbamp, 1, -120.dbamp], times:[0,1], curve: -5).ar;
	fb = LocalIn.ar(1);
	fb = NonlinearFilter.ar(fb, freq: 900, q: 0.1, gain: 0.3, shape: 1, saturation: 3);
	fb = AnalogPhaser.ar(fb, fb, feedback: 0.4, stages: 12);
/*	100.do {
		fb = Allpass1.ar(fb, apfreq);
	};*/
	input = input + fb;
	// input = (input * inputenv) + fb;

	ph = Phasor.ar(Impulse.ar(0), phasorfreq * SampleDur.ir, resetPos: [0, 0.25, 0.5, 0.75]);
	de = (ph * pi).sin.squared;
	dt = (ph * phasoramp) + constdelay;
	dt = dt * 1e-3;
	delays = DelayC.ar(input, 10, dt - ControlDur.ir);
	delays = delays * de;
	delays = Mix(delays);

	delays = LeakDC.ar(delays, 0.989);
	delays = delays.hp(40);
	delays = BPeakEQ.ar(delays, 180, 0.2, \subBassGainRed.kr(-15));
	delays = OnePole.ar(delays, \damping.kr(0));
	rms = RunningSum.rms(delays, rmswindow);
	rms = pow(fbbase, rms.neg) * fbgain;

	// rms.poll;
	LocalOut.ar(delays * rms);
	// delays.dup

	output = delays;

	compSendKikLvl = \compSendKik.kr(-100);
	compSendZapLvl = \compSendZap.kr(-100);
	compSendSubLvl = \compSendSub.kr(-100);

	compSendSig = kikIn * Select.kr(compSendKikLvl < (-90), [compSendKikLvl, -inf]).dbamp;
	compSendSig = compSendSig + (zapIn * Select.kr(compSendZapLvl < (-90), [compSendZapLvl, -inf]).dbamp);
	compSendSig = compSendSig + (subIn * Select.kr(compSendSubLvl < (-90), [compSendSubLvl, -inf]).dbamp);


	amplitudeDb = Amplitude.ar(compSendSig, \compAtk.kr(0.001), \compRel.kr(0.03)).ampdb;
	// amplitudeDb.poll(5, "amplitudeDb");
	gainDb = ((amplitudeDb - \compThresh.kr(-10)) * (1 / \ratio.kr(4) - 1)).min(0);
	// gainDb.dbamp.poll(5, "gainDb");


	output = output * gainDb.dbamp;
	output = delays.blend(GVerb.ar(delays, 40, 10, 0.8, 0.2), \verbBlendAmt.kr(0.05));
	output = output * \outputGain.kr(0).dbamp;
	// output.poll;


	// snd * 0.1!2;

	output
};

Ndef(\zap, ~zapDef);
Ndef(\kik, ~kikDef);
Ndef(\sub, ~subDef);
Ndef(\del4, ~delDef);
)

// end proxies
// (
Ndef(\zap).end;
Ndef(\kik).end;
Ndef(\sub).end;
Ndef(\del4).end;
// )

Ndef(\del4).gui




// main proxy section
Ndef(\zap).clear.ar(2);
Ndef(\zap).fadeTime = 0;
Ndef(\zap).quant = -4;

(
~zapDef = {
	var imp, tempo, seq, hit;
	var zap, zapPitchEnv, zapAmpEnv, zapEnvTime, zapEnvCur, zapPitchEnvHi;

	tempo = ~tempoproxy.kr;
	imp = Impulse.ar(tempo*4);

	seq = [
		[ 1, 0, 0, 1,  1, 0, 1, 1,  0, 1, 0, 0,  1, 0, 0, 1 ],
		[ 1, 0, 1, 0,  0, 0, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 ],
		[ 1, 0, 0, 1,  0, 0, 1, 0,  1, 0, 0, 0,  0, 1, 0, 1 ],
		[ 0, 0, 1, 1,  0, 0, 0, 0,  1, 0, 0, 0,  1, 0, 0, 0 ],

		[ 1, 0, 1, 0,  0, 0, 0, 1,  0, 0, 1, 1,  1, 0, 0, 1 ],
		[ 0, 1, 0, 0,  0, 0, 1, 0,  0, 1, 0, 1,  0, 0, 0, 0 ],
		[ 1, 0, 0, 1,  0, 0, 1, 0,  1, 0, 0, 0,  0, 1, 1, 1 ],
		[ 0, 0, 1, 1,  0, 0, 0, 0,  1, 0, 0, 0,  1, 0, 0, 0 ]
	].flat;

	hit = Demand.ar(imp, Impulse.ar(0), Dseq(seq,inf)) * imp;

	zapEnvTime = \zapEnvTime.kr(0.1);
	zapEnvCur = \zapEnvCur.kr(0);

	zapPitchEnvHi = \zapPitchEnvHi.kr(9e3);
	zapPitchEnv = Env.perc(0, zapEnvTime, 1, zapEnvCur).ar(gate: hit).linexp(0, 1, \zapPitchEnvLo.kr(100), zapPitchEnvHi);
	zapAmpEnv = Env.perc(0, zapEnvTime, 1, zapEnvCur).ar(gate: hit);
	zap = SinOsc.ar(zapPitchEnv) * zapAmpEnv;
	// zap = PulseDPW.ar(\f1.asNote.midicps, 0.4, 0.4) * zapAmpEnv;
	zap = SVF.ar(zap, zapPitchEnv.lag(0.1), 0.8, 1);
	// zap = zap + MiPlaits.ar(zapPitchEnv, 8, 0.05, 0.1, 0.5, zap.dup, decay: 0.9, lpg_colour: 0.1);
	// zap = AnalogFoldOsc

	Pan2.ar(zap) * -30.dbamp
};
)
Ndef(\zap, ~zapDef);

(
Ndef('zap').set('zapEnvCur', -8.7301587301587, 'zapPitchEnvLo', 140.13241651547, 'zapEnvTime', 0.17946024402973, 'zapPitchEnvHi', 10066.828617371);
Ndef(\zap).addSpec(
	\zapEnvTime, [0.001, 1, \exp],
	\zapEnvCur, [-20, 10, \lin, 0, 0],
	\zapPitchEnvHi, [300, 12000, \exp],
	\zapPitchEnvLo, [10, 6000, \exp],
);
)
Ndef(\zap).play
Ndef(\zap).stop
Ndef(\zap).end
Ndef(\zap).gui

(
Ndef(\kik).end;
Ndef(\zap).end;
)

(
Ndef(\kik, ~kikDef);
Ndef(\kik).play;
Ndef(\zap, ~zapDef);
Ndef(\zap).play;
)




Ndef(\kik).clear.ar(2);
Ndef(\kik).fadeTime = 0;
Ndef(\kik).quant = -4;
(
~kikDef = {
	var imp, tempo, seq, hit;
	var kik, kikPitchEnv;

	tempo = ~tempoproxy.kr;
	// (tempo * 60).poll;
	imp = Impulse.ar(tempo*2);

	seq = [
		[ 1, 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0 ],
		[ 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0 ],
		[ 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 1 ],
		[ 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0 ],

		[ 1, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0 ],
		[ 0, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0 ],
		[ 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1 ],
		[ 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0 ],

		[ 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 0, 1, 0 ],
		[ 0, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0 ],
		[ 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1 ],
		[ 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0 ],

		[ 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0 ],
		[ 0, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0 ],
		[ 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1 ],
		[ 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0 ]
	].flat;

	hit = Demand.ar(imp, Impulse.ar(0), Dseq(seq,inf)) * imp;
	kikPitchEnv = Env([1,1,\pitchLo.kr(0.8)], [0.01, \pitchDur.kr(0.14)], \pitchCurve.kr(0)).ar(gate: hit);
	// kik = Ringz.ar(hit.lp(700), \fundamental.kr(52) * XLine.ar(1, \pitchLo.kr(0.8), \pitchDur.kr(0.14)), \decay.kr(0.2)) * -5.dbamp;
	kik = Ringz.ar(hit.lp(700), \fundamental.kr(52) * kikPitchEnv, \decay.kr(0.2)) * \outGain.kr(5).dbamp;

	Pan2.ar(kik) * -10.dbamp
};
)
(
Ndef(\kik, {
	var imp, tempo, seq, hit;
	var kik, kikPitchEnv;

	tempo = ~tempoproxy.kr;
	// (tempo * 60).poll;
	imp = Impulse.ar(tempo*2);

	seq = [
		[ 1, 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0 ],
		[ 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0 ],
		[ 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 1 ],
		[ 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0 ],

		[ 1, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0 ],
		[ 0, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0 ],
		[ 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1 ],
		[ 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0 ],

		[ 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 0, 1, 0 ],
		[ 0, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0 ],
		[ 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1 ],
		[ 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0 ],

		[ 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0 ],
		[ 0, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0 ],
		[ 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1 ],
		[ 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0 ]
	].flat;

	hit = Demand.ar(imp, Impulse.ar(0), Dseq(seq,inf)) * imp;
	kikPitchEnv = Env([1,1,\pitchLo.kr(0.8)], [0.01, \pitchDur.kr(0.14)], \pitchCurve.kr(0)).ar(gate: hit);
	// kik = Ringz.ar(hit.lp(700), \fundamental.kr(52) * XLine.ar(1, \pitchLo.kr(0.8), \pitchDur.kr(0.14)), \decay.kr(0.2)) * -5.dbamp;
	kik = Ringz.ar(hit.lp(700), \fundamental.kr(52) * kikPitchEnv, \decay.kr(0.2)) * \outGain.kr(5).dbamp;

	Pan2.ar(kik) * -10.dbamp
});
Ndef(\kik).addSpec(
	\fundamental, [20, 300, \exp, 0, 52],
	\pitchLo, [0.1, 2, \lin, 0, 0.8],
	\pitchDur, [0, 1.3, \lin, 0, 0.14],
	\pitchCurve, [-10, 10, \lin, 0, 0],
	\decay, [0, 1.3, \lin, 0, 0.2]
);
)
Ndef('kik').set('decay', 0.075661375661376, 'pitchLo', 0.91428571428571, 'pitchCurve', -7.5661375661376, 'fundamental', 40.midicps, 'pitchDur', 0.048148148148148);

Ndef(\kik).play
Ndef(\kik).stop
Ndef(\kik).end
Ndef(\kik).gui




Ndef(\sub).clear.ar(2);
Ndef(\sub).fadeTime = 0;
Ndef(\sub).quant = -4;
(
Ndef(\sub, {
	var sig, imp, tempo, seq, hit;
	var kik, kikPitchEnv;
	var env, formantEnv, verb, verbLp, verbHp, verbFilterEnv;
	var mod = SinOsc.kr(0.1);


	tempo = ~tempoproxy.kr;
	// (tempo * 60).poll;
	imp = Impulse.ar(tempo*2);

	seq = [
		[ 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0 ],
		[ 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0 ]
	].flat;

	seq = [
		[ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0 ],
		[ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
	].flat;

	hit = Demand.ar(imp, Impulse.ar(0), Dseq(seq,inf)) * imp;

	env = Env.perc(tempo.reciprocal / 16, 0.5, 1, \welch).ar(gate: hit);
	formantEnv = Env([0,2pi,0], [tempo/8, tempo/4]).ar(gate: hit).sin.pow(tempo).exprange(1, 60);
	formantEnv = SinOsc.kr(tempo/2).pow(tempo * 1).exprange(1,LFDNoise3.kr(0.6).range(70, 70));

	sig = ZOsc.ar(
		freq: (40-9).midicps * LFNoise2.kr(0.5).exprange(0.995,1.005),
		formantfreq: formantEnv,
		shape: 0.99,
		mode: -0.99
	);
	sig = sig.hp(100) * env;
	sig = sig.blend(BPeakEQ.ar(sig, 120, 1.6, -10), 0.5);
	verb = DWGReverbC1C3.ar(sig.hp(100), 2000, 1.8, 100, 1);

	verbFilterEnv = Env([40, 8000, 40], [0.03, tempo.reciprocal/8], -3).ar(gate: hit).lag(0.1);
	// verbHp = SVF.ar(verb, LFSaw.ar(tempo*2, 1.2).exprange(8000, 10).lag(0.3), 0.8, 0, 0, 1); // adjust second arg of lfsaw
	verbHp = SVF.ar(verb, verbFilterEnv, 0.7, 0, 0, 0.8);
	verbHp = verbHp * Env([0,0,1], [0.4, tempo.reciprocal/4], -5).ar(gate: hit);
	// verbHp = verbHp * Env.asr(0.03, 1, tempo.reciprocal/8*0.1, 3).ar(gate: Trig1.kr(hit, tempo.reciprocal/16)).poll;
	verbHp = verbHp.blend(BPeakEQ.ar(verbHp, 360, 1.2, 20), 0.3);
	// verbHp = verbHp + CombC.ar(verbHp * -9.dbamp, 0.55, 0.55, tempo.reciprocal * 0.8);
	verb = verbHp.hp(340);
	verb = NumChannels.ar(verb);
	sig = sig.blend(verb, 0.3);
	Pan2.ar((sig * 1.3).tanh * -19.dbamp, 0);
});
Ndef(\sub).addSpec(
	\fundamental, [20, 300, \exp, 0, 49],
	\pitchLo, [0.1, 2, \lin, 0, 0.8],
	\pitchDur, [0, 1.3, \lin, 0, 0.14],
	\pitchCurve, [-10, 10, \lin, 0, 0],
	\decay, [0, 1.3, \lin, 0, 0.2]
);
)

Ndef(\sub).play
Ndef(\sub).stop
Ndef(\sub).end
Ndef(\sub).gui




(
Ndef(\del4).clear;
Ndef(\del4).ar(2);
)
(
Ndef(\del4, {
	|phasorfreq=(2.3), phasoramp=120, constdelay=73, apfreq=1000, rmswindow=512, fbbase=120, fbgain=1.1|
	var input, inputenv, fb, output;
	var kikIn, zapIn, subIn;
	var compSendSig, compSendKikLvl, compSendZapLvl, compSendSubLvl;
	var signalIn, sig0level, sig1level, sig2level, sig3level, sig4level, sig5level;
	var phasor, dellinetime, dellineenv, delline;
	var delays, rms;
	var ph, dt, de, del;
	var amplitudeDb, gainDb;
	var attack = 0.001, release = 0.03;
	var threshold = (-10), ratio=4;

	sig0level = \kikLvl.kr(-100, 0.1);
	sig1level = \zapLvl.kr(-100, 0.1);
	sig2level = \subLvl.kr(-100, 0.1);
	// sig3level = \blablaLvl.kr(-100, 0.1);
	// sig4level = \blablaLvl.kr(-100, 0.1);
	// sig5level = \blablaLvl.kr(-100, 0.1);

	kikIn = Ndef(\kik).ar;
	zapIn = Ndef(\zap).ar;
	subIn = Ndef(\sub).ar;

	signalIn = Silence.ar.dup;
	signalIn = kikIn * Select.kr(sig0level < (-90), [sig0level, -inf]).dbamp;
	signalIn = signalIn + (zapIn * Select.kr(sig1level < (-90), [sig1level, -inf]).dbamp);
	signalIn = signalIn + (subIn * Select.kr(sig2level < (-90), [sig2level, -inf]).dbamp);

	// input = Impulse.ar(144/60/4);
	input = signalIn;



	// input = LPF.ar( Ringz.ar(input, 51 * XLine.ar(1, 0.8, 0.14), 0.8 ), 700 ) * -5.dbamp;
	// input = Blip.ar(60.midicps, mul: 0.1);
	inputenv = Env([-120.dbamp, 1, -120.dbamp], times:[0,1], curve: -5).ar;
	fb = LocalIn.ar(1);
	fb = NonlinearFilter.ar(fb, freq: 900, q: 0.1, gain: 0.3, shape: 1, saturation: 3);
	fb = AnalogPhaser.ar(fb, fb, feedback: 0.4, stages: 12);
/*	100.do {
		fb = Allpass1.ar(fb, apfreq);
	};*/
	input = input + fb;
	// input = (input * inputenv) + fb;

	ph = Phasor.ar(Impulse.ar(0), phasorfreq * SampleDur.ir, resetPos: [0, 0.25, 0.5, 0.75]);
	de = (ph * pi).sin.squared;
	dt = (ph * phasoramp) + constdelay;
	dt = dt * 1e-3;
	delays = DelayC.ar(input, 10, dt - ControlDur.ir);
	delays = delays * de;
	delays = Mix(delays);

	delays = LeakDC.ar(delays, 0.989);
	delays = delays.hp(40);
	delays = BPeakEQ.ar(delays, 180, 0.2, -20);
	rms = RunningSum.rms(delays, rmswindow);
	rms = pow(fbbase, rms.neg) * fbgain;

	// rms.poll;
	LocalOut.ar(delays * rms);
	// delays.dup

	output = delays;

	compSendKikLvl = \compSendKik.kr(-100);
	compSendZapLvl = \compSendZap.kr(-100);
	compSendSubLvl = \compSendSub.kr(-100);

	compSendSig = kikIn * Select.kr(compSendKikLvl < (-90), [compSendKikLvl, -inf]).dbamp;
	compSendSig = compSendSig + (zapIn * Select.kr(compSendZapLvl < (-90), [compSendZapLvl, -inf]).dbamp);
	compSendSig = compSendSig + (subIn * Select.kr(compSendSubLvl < (-90), [compSendSubLvl, -inf]).dbamp);


	amplitudeDb = Amplitude.ar(compSendSig, \compAtk.kr(0.001), \compRel.kr(0.03)).ampdb;
	// amplitudeDb.poll(5, "amplitudeDb");
	gainDb = ((amplitudeDb - \compThresh.kr(-10)) * (1 / \ratio.kr(4) - 1)).min(0);
	gainDb.dbamp.poll(5, "gainDb");


	output = output * gainDb.dbamp;
	output = delays.blend(GVerb.ar(delays, 40, 10, 0.8, 0.2), \verbBlendAmt.kr(0.05));
	output = output * \outputGain.kr(0).dbamp;
	// output.poll;


	// snd * 0.1!2;

	output
});

Ndef(\del4).addSpec(
	\phasorfreq, [0, 10],
	\phasoramp, [0, 400],
	\constdelay, [0, 300],
	\apfreq, \freq,
	\fbbase, [1, 200, \exp, 0, 4],
	\fbgain, [0.4,1.5, \lin, 0, 1.1],
	\kikLvl, [-100, 0, \lin, 0, -100],
	\zapLvl, [-100, 0, \lin, 0, -100],
	\subLvl, [-100, 0, \lin, 0, -100],
	\compSendKik, [-100, 20, \lin, 0, -100],
	\compSendZap, [-100, 20, \lin, 0, -100],
	\compSendSub, [-100, 20, \lin, 0, -100],
	\compAtk, [0.0001, 0.1, \exp, 0, 0.001],
	\compRel, [0.01, 0.3, \exp, 0, 0.03],
	\compThresh, [-90, 0, \lin, 0, -5, 0],
	\compRatio, [1, 40, \lin, 0, 4],
	\verbBlendAmt, \unipolar,
	\outputGain, [-40, 40, \lin, 0, 0]
);
)

Ndef(\del4).play
Ndef(\del4).vol = 0
Ndef(\del4).stop(5)
Ndef(\del4).gui
Ndef(\del4).end




(
Ndef(\trak2mixer).clear;
Ndef(\trak2mixer).ar(2);
)
(
Ndef(\trak2mixer, {
	var local;
	var attack = \attack.kr(0.01);
	var release = \release.kr(0.1);
	var dry, drywet, in, t, o, r, c, e;
	var lookahead, lookdelay;
	var kneelag;
	var bias;
	var input, kikIn, zapIn, subIn, delIn;
	var kikLvl, zapLvl, subLvl, delLvl, sig4level, sig5level;
	var amplitudeDb, gainDb;


	kikIn = Ndef(\kik).ar;
	zapIn = Ndef(\zap).ar;
	subIn = Ndef(\sub).ar;
	delIn = Ndef(\del4).ar;

	kikLvl = \kikMasterLvl.kr(-100);
	zapLvl = \zapMasterLvl.kr(-100);
	subLvl = \subMasterLvl.kr(-100);
	delLvl = \delMasterLvl.kr(-100);

	input = kikIn * Select.kr(kikLvl < (-90), [kikLvl, -inf]).dbamp;
	input = input + (zapIn * Select.kr(zapLvl < (-90), [zapLvl, -inf]).dbamp);
	input = input + (subIn * Select.kr(subLvl < (-90), [subLvl, -inf]).dbamp);

	amplitudeDb = Amplitude.ar(kikIn * 15.dbamp, \sideChainAtk.kr(0.001), \sideChainRel.kr(0.03)).ampdb;
	// amplitudeDb.poll(5, "amplitudeDb");
	gainDb = ((amplitudeDb - \sideChainThresh.kr(-10)) * (1 / \sideChainRatio.kr(4) - 1)).min(0);
	// gainDb.dbamp.poll(5, "gainDb");

	delIn = delIn * gainDb.dbamp;
	input = input + (delIn * Select.kr(delLvl < (-90), [delLvl, -inf]).dbamp);




	dry = input;


	t = \threshold.kr(-6);

	in = dry * \trim.kr(0).dbamp;

	e = in.mean;

	e = HPF.ar(e, \hpf.kr(50));
	e = EnvDetect.ar(e, attack, release);

	o = e.ampdb.excess(t);

	r = \ratio.kr(4);
	c = max(o, 0.0) * (r.reciprocal - 1);
	kneelag = attack * \knee.kr(0.0);
	c = c.lag(kneelag);
	c = c.dbamp;

	lookahead = \lookahead.kr(0);
	lookdelay = (attack + release + kneelag * lookahead).lag(0.4);
	in = DelayC.ar(in, 0.5, lookdelay);
	in = in * c;
	in = in * \gain.kr(0).dbamp;
	in = Select.ar(\saturate.kr(1), [in, in.softclip]);
	in = LeakDC.ar(in);

	drywet = \dry_wet.kr(1);
	Mix([
		in * drywet,
		DelayC.ar(dry * (1 - drywet), 0.5, lookdelay)
	])

});
)
(
Ndef(\trak2mixer).addSpec(
	\kikMasterLvl, [-100, 0, \lin, 0, -100],
	\zapMasterLvl, [-100, 0, \lin, 0, -100],
	\subMasterLvl, [-100, 0, \lin, 0, -100],
	\delMasterLvl, [-100, 0, \lin, 0, -100],
	\sideChainAtk, [0.0001, 0.1, \exp, 0, 0.001],
	\sideChainRel, [0.01, 0.3, \exp, 0, 0.03],
	\sideChainThresh, [-90, 0, \lin, 0, -5, 0],
	\sideChainRatio, [1, 40, \lin, 0, 4],
	\attack, [0.0000001,0.1, \exp],
	\release, [0.0000001,0.4, \exp],
	\threshold, [0,-120],
	\trim, [0,60],
	\gain, [0,60],
	\ratio, [1,20, \exp],
	\lookahead, [0.0,1],
	\saturate, \switch,
	\dry_wet, [0,1],
	\hpf, [10, 1000],
	\knee, [0.0, 10],
	\bias, [0.0, 0.5],

);
)

Ndef(\trak2mixer).gui
Ndef(\del4).gui
Ndef(\kik).gui




// presets
Ndef('del4').set('compAtk', 0.019306977288832, 'phasorfreq', 3.1216931216931, 'subBassGainRed', -5.5555555555556, 'constdelay', 149.20634920635, 'outputGain', -8.2539682539683, 'verbBlendAmt', 0.76719576719577, 'compSendKik', -6.031746031746, 'compThresh', -71.428571428571, 'kikLvl', -35.449735449735, 'damping', 0.23280423280423, 'fadeTime', 0.07, 'zapLvl', -93.121693121693, 'compRel', 0.15415207281739, 'subLvl', -1.5873015873016, 'phasoramp', 50.793650793651);

Ndef('trak2mixer').set('sideChainAtk', 0.040102791394952, 'sideChainRatio', 31.333333333333, 'delMasterLvl', -12.169312169312, 'subMasterLvl', -9.5238095238095, 'sideChainRel', 0.14605048373846, 'trim', 6.6666666666667, 'gain', 6.984126984127, 'kikMasterLvl', -11.111111111111, 'zapMasterLvl', -100.0, 'sideChainThresh', -66.666666666667);
