// seg3

/*
steps

1. slowly lower oscBpfBlend from 1 to 0
2. carefully open shelfgain1 to 20
3. even more carefully open shelfgain2 to -10
4. lower chorusblend
5. increase second noise blend to 1
6. mess with noise freq lo and hi
7. increase noisecurve to pronounce noise curve effect

*/

// main proxy
Ndef(\chord).clear.ar(2);
Ndef(\chord).fadeTime = 50;
Ndef(\chord).quant = -1;
(
Ndef(\chord, {
	var opA, opB, opC, opD;
	var oscPhaseA, oscPhaseB, oscPhaseC, oscPhaseD;
	var ampEnvA, ampEnvB, ampEnvC, ampEnvD;
	var pitchEnv, pitchEnvScale=(-40), attackPitchEnvA;
	var levelA, levelB, levelC, levelD;
	var f0, coarseB, fineB, freqA, freqB, freqC, freqD;
	var wtBufA, noiseLoopBuf;
	var wtBufFrames=2048, noiseLoopBufFrames=(wtBufFrames), noiseLoopRateC;
	var carr, mod;
	var chorus, chorusCount=3;
	var preHiShelfRq;

	ampEnvA=1; ampEnvB=1;

	#levelA, levelB = [-10, -10].dbamp;


	// f0 = [\f4, \gs4, \as4, \c5, \cs5, \ds4].collect(_.asNote).midicps / 1.5 * 1;
	f0 = (\c4.asNote + (0,9/4..8)).midicps/1.8;
	f0 = (\f4.asNote + Scale.chromatic(Tuning.just).as(Array)[[\f4, \gs4, \as4, \c5, \cs5].collect(_.asNote) - 65]).midicps/1.5;
	// f0 = (\c4.asNote + Scale.partch_o1.degrees[[1, 3, 4, 5]]).midicps /2 * 1;
	// f0 = (\c4.asNote + Scale.pelog.degrees[[2, 0, 1]]).midicps /2 * 1;
	// f0 = f0 ++ [f0/2];l
	// f0 = f0 ++ [f0*2];



	f0 = f0;
	// f0 = f0 ++ [f0/8] ++ [f0/4] ++ [f0/2] ++ [f0*2] ++ [f0 * 4] ++ [f0 * 8] ++ [f0 * 10] ++ [f0 * 3] ++ [f0 * 5] ++ [f0 * 6];

	f0 = f0 +.t (0.5,1..2);
	f0 = f0.clump(2);
	f0 = f0 * (LFDNoise3.ar([13, 9, 11, 7]).range(0.97,1.03));

	opB = Osc.ar(~wtBufTuesChord, f0);
	// opB = opB + NeoFormant.ar(f0 * 8, f0*3, {1.0.rand ! 4});
	// opB = Formant.ar(f0, f0 * 2.0104, f0 * 1.012);
	opB = opB * levelB;

	mod = opB * -30.dbamp;
	mod = mod * f0;

	// mod.poll;

	opA = SinOsc.ar(f0 + (mod * f0)).sum * sqrt(5).reciprocal * -20.dbamp;

	opA = opA.blend(BPF.ar(opA, \oscBpfFreq.kr(500), \oscBpfRq.kr(3)), \oscBpfBlend.kr(0));

	// opA = AnalogPhaser.ar(opA, SinOsc.ar(0.59), feedback: 0.0, modulation: 0.5, stages: 50);
	chorus = 2.collect { |i|
		DelayC.ar(opA, 0.1, SinOsc.ar(0.3, ((0..chorusCount - 1) + (i * 0.5)) / chorusCount * 2pi).linlin(-1, 1, 4e-3, 15e-3)).sum / sqrt(chorusCount) * 0.dbamp;
	};
	chorus = 2.collect { |i|
		DelayC.ar(chorus, 0.1, SinOsc.ar(0.4, ((0..chorusCount - 1) + (i * 0.5)) / chorusCount * 2pi).linlin(-1, 1, 6e-3, 19e-3)).sum / sqrt(chorusCount) * 0.dbamp;
	};
	opA = BHiShelf.ar(opA, 1800, preHiShelfRq=\preHiShelfRq.kr(2), \preHiShelfGain1.kr(20));
	opA = opA.blend(chorus, \chorusBlend.kr(0));h
	// opA = NumChannels.ar(GVerb.ar(opA, 220, 1, 0.2, 0.6, 30, 0, 1, 1, 400), 2);
	// opA = MiVerb.ar(opA * -20.dbamp, 0.6, 1, 0.4, diff: 0.6);
	opA = BHiShelf.ar(opA, 1500, preHiShelfRq, \preHiShelfGain2.kr(-10));

	opA = JPverbRaw.ar(opA.at(0), opA.at(1), 0.5, earlydiff: 1, mdepth: 0, mfreq: 0.59,  size: 5, t60: 10);
	opA = LFDNoise3.ar([25, 23, 14, 29]).range(0,1).lincurve(0,1,0.3,1,\firstNoiseCurve.kr(-6)) * opA;
	opA = opA.clump(2).sum / sqrt(4);
	opA = opA.blend(LFDNoise3.kr(LFDNoise3.kr(LFDNoise3.kr(1).range(0.1, 5)).range(\scndNoiseFreqLo.kr(0.3), \scndNoiseFreqHi.kr(2))).range(0,1).lincurve(0,1,LFDNoise3.kr(0.4).range(0, 0.8),1,LFDNoise3.kr(0.5).range(\scndNoisePowerCurveLo.kr(-4), \scndNoisePowerCurveHi.kr(20))) * opA, \scndNoiseBlend.kr(0));
	opA = MiVerb.ar(opA * 0.dbamp, 0.8, 0.05, 0.9, diff: 0.6);
	opA = BBandStop.ar(opA, LFDNoise3.kr(0.42).range(640, 990), 1.5);
	opA = BBandStop.ar(opA, LFDNoise3.kr(0.51).range(120, 590), 3);
	opA = BPeakEQ.ar(opA, 180, 0.6, \postPeakEqGain.kr(-30));
	opA = BHiShelf.ar(opA, 1000, 3, \postHiShelfGain1.kr(-10));
	opA = BHiShelf.ar(opA, 3000, 1, \postHiShelfGain2.kr(-15));
	opA = (opA.clean * 1.6).tanh;
	// opA = SinOsc.ar(f0 + (SinOsc.ar(f0) * f0 * 20)).sum * sqrt(5).reciprocal;
	Pan2.ar(opA) * 12.dbamp
	// carr =
});
Ndef(\chord).addSpec(
	\oscBpfBlend, \unipolar,
	\oscBpfFreq, [200, 6000, \exp, 0, 500],
	\oscBpfRq, [1, 3, \lin, 0, 2],
	\preHiShelfGain1, [-20, 20, \lin, 0, 20],
	\preHiShelfGain2, [-20, 20, \lin, 0, 20],
	\preHiShelfRq, [1, 2, \lin, 0, 2],
	\chorusBlend, \unipolar,
	\firstNoiseCurve, [-15, 15, \lin, 0, -6],
	\scndNoiseBlend, \unipolar,
	\scndNoiseFreqLo, [0.1, 2, \lin, 0, 1],
	\scndNoiseFreqHi, [0.1, 50, \lin, 0, 100],
	\scndNoisePowerCurveLo, [-20, 10, \lin, 0, -4],
	\scndNoisePowerCurveHi, [-10, 30, \lin, 0, 20],
	\postPeakEqGain, [-40, -10, \lin, 0, -30],
	\postHiShelfGain1, [-30, 20, \lin, 0, -10],
	\postHiShelfGain2, [-50, 20, \lin, 0, -15],

);
Ndef(\chord).play;
Ndef('chord').set('oscBpfFreq', 4339.8331777616, 'oscBpfRq', 1.2645502645503, 'chorusBlend', 1.0, 'postHiShelfGain2', -14.51, 'scndNoisePowerCurveLo', -1.1957671957672, 'secondNoiseBlend', 0.0064036860306257, 'postPeakEqGain', -10.0, 'preHiShelfRq', 1.0, 'preHiShelfGain2', -19.57671957672, 'preHiShelfGain1', -20.0, 'fadeTime', 20, 'postHiShelfGain1', -10.687830687831, 'scndNoiseBlend', 0.0, 'scndNoiseFreqLo', 0.36137566137566, 'oscBpfBlend', 1.0, 'scndNoisePowerCurveHi', 16.243386243386, 'scndNoiseFreqHi', 0.1, 'firstNoiseCurve', -12.743386243386);
)

Ndef(\chord).gui
